#ifndef CFILE_HH
#define CFILE_HH

#include "global.hh"

class Cfile
{
public:
  Cfile();
  ~Cfile();

private:
  /* act on this file */
  FILE* m_fp;

public:
  /* open binary file to read */
  int fopen_rb(std::string binary_filename);
  /* open txt file to read */
  int fopen_r(std::string txt_filename);
  /* open binary file to write */
  int fopen_wb(std::string binary_filename);
  /* open txt file to write */
  int fopen_w(std::string txt_filename);

public:
  /* to read binary */
  int read_one_block(data_t data_block[]);
  /* to read txt */
  int read_line(char* buf, size_t size);

  /* to write binary */
  template<class T> int write_binary(T buf)
  {
    fwrite(&buf, sizeof(T), 1, m_fp);
    return OK;
  }
  int write_binary(const void* buf, size_t size);
  /* to write txt */
  int write_word(char buf);
  int write_word(char* buf);  
  int write_word(std::string buf);
  int write_word(int buf);
  int write_one_block(data_t data_block[]);/* (row,collumn)=(1000,16byte) */

  /*go back one block*/
  int seek_back_one_block();
};

#endif
